#include <windows.h>
#pragma hdrstop
#include <condefs.h>
#include "DynamicDLLTestWndProcFunctions.h"

USEUNIT("DynamicDLLTestWndProcFunctions.cpp");
USEUNIT("DynamicDLLTestWMCommandFunctions.cpp");
//---------------------------------------------------------------------------
LRESULT CALLBACK WndProc (HWND hWnd, UINT nMsg, UINT wParam, LONG lParam);

HINSTANCE hInst = 0;

//---------------------------------------------------------------------------
#pragma argsused
WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR, int nCmdShow)
{
   static char sWindowclassname [] = "DynamicDLLTest";
   HWND        hWindow;
   MSG         aMessage;
   WNDCLASS    aWindowclass;

   hInst = hInstance;

   if (!hPrevInstance)
   {
      aWindowclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWindowclass.lpfnWndProc   = WndProc;
      aWindowclass.cbClsExtra    = 0;
      aWindowclass.cbWndExtra    = 0;
      aWindowclass.hInstance     = hInstance;
      aWindowclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWindowclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      aWindowclass.hbrBackground = (HBRUSH)GetStockObject (WHITE_BRUSH);
      aWindowclass.lpszMenuName  = NULL;
      aWindowclass.lpszClassName = sWindowclassname;

      if (!RegisterClass (&aWindowclass))
      {
         MessageBox (NULL, "RegisterClass", "FEHLER", MB_OK);
         return 0;
      }
   }

   hWindow = CreateWindow (sWindowclassname, "DynamicDLLTest",
         WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT,
         CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance,
         NULL);

   if (!hWindow)
   {
      MessageBox (NULL, "CreateWindow", "FEHLER", MB_OK);
      return 0;
   }

   ShowWindow (hWindow, nCmdShow);

   if (!UpdateWindow (hWindow))
   {
      MessageBox (NULL, "UpdateWindow", "FEHLER", MB_OK);
      return 0;
   }

   while (GetMessage (&aMessage, NULL, 0, 0))
   {
      TranslateMessage (&aMessage);
      DispatchMessage (&aMessage);
   }
   return aMessage.wParam;
}

//------------------------------------------------------------
LRESULT CALLBACK WndProc (HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
   switch (nMsg)
   {
      case WM_CREATE:     return fnWMCreate     (hWnd, wParam, lParam);
      case WM_SHOWWINDOW: return fnWMShowWindow (hWnd, wParam, lParam);
      case WM_COMMAND:    return fnWMCommand    (hWnd, wParam, lParam);
      case WM_DESTROY :   return fnWMDestroy    (hWnd, wParam, lParam);
   }
   return DefWindowProc (hWnd, nMsg, wParam, lParam);
}

