#include <dir.h>
#include "DynamicDLLTestWMCommandFunctions.h"
#include "UseDLLFunctionBase.h"

//==============================================================================
// Aufruf einer Funktion in der ausgewhlten DLL                               -
//==============================================================================
#pragma argsused
int fnButton (HWND hwnd, WPARAM wParam, LPARAM lParam, int nListboxID)
{
   char      szDLLPfad [MAXPATH]; // Namensspeicher fr die DLL incl. Pfad
   char      szFileLB  [MAXPATH]; // Namensspeicher fr die DLL
   HINSTANCE hInstDLL;            // Instanzen-Handle fr die DLL
   BOOL      bRet = TRUE;         // Returnwert
   LRESULT   nIdx = LB_ERR;       // Index des in Listbox selekt. Eintrags
   char     *pszHelp;             // Hilfspointer f. Zeichenkettenmanipulation
   HWND      hLB;                 // Pufferspeicher fr Listbox-Handle

   UseDLLFunctionBase  *(FAR *lpfn) (void);  // Ptr auf eine in DLL enthaltener Funktion
   UseDLLFunctionBase  *test = NULL;         // Pointer um Returnwert aufzunehmen

   //---------------------------------------------------------------------------
   // Handle der Listbox ermitteln
   //---------------------------------------------------------------------------
   hLB = GetDlgItem (hwnd, nListboxID);

   //---------------------------------------------------------------------------
   // Namen der DLL aus der Listbox ermitteln und kompletten Pfadnamen bilden
   // dazu zunchsteinmal den Startpfad des Hauptprogramms ermitteln
   //---------------------------------------------------------------------------
   strcpy (szDLLPfad, _argv[0]);
   pszHelp = strrchr (szDLLPfad, '\\');
   if (pszHelp)
   {
   	pszHelp++;
   	*pszHelp = '\0';
   }

   //---------------------------------------------------------------------------
   // Namen der selektierten DLL holen und mit Pfad zusammenbauen
   //---------------------------------------------------------------------------
   nIdx = SendMessage (hLB, LB_GETCURSEL, (WPARAM)0, (LPARAM)0);
   if (LB_ERR == nIdx)
   {
      bRet = FALSE;
      MessageBox (NULL, "Kein Name in der Listbox gewhlt", "SELECTDLL",
      MB_OK|MB_TASKMODAL|MB_ICONSTOP);
   }
   else
   {
      SendMessage (hLB, LB_GETTEXT, (WPARAM)nIdx, (LPARAM)szFileLB);
      strcat (szDLLPfad, szFileLB);
   }

   //---------------------------------------------------------------------------
   // Wenn der DLL-Pfad erfolgreich gebildet werden konnte, dann DLL laden
   //---------------------------------------------------------------------------
   if (bRet)
   {
      //------------------------------------------------------------------------
      // DLL dynamisch nachladen
      //------------------------------------------------------------------------
      hInstDLL = LoadLibrary (szDLLPfad);

      //------------------------------------------------------------------------
      // Konnte DLL geladen werden ?
      //------------------------------------------------------------------------
      if (HINSTANCE_ERROR >= (int)hInstDLL)
      {
         bRet = FALSE;
         MessageBox (NULL, szDLLPfad, "DLL konnte nicht geladen werden",
                     MB_OK|MB_TASKMODAL|MB_ICONSTOP);
      }
      else
      {
         //---------------------------------------------------------------------
         // DLL konnte geladen werden. Jetzt die Adresse d. gewnschten Funktion
         // holen. 
         //---------------------------------------------------------------------
         (FARPROC)lpfn = GetProcAddress (hInstDLL, "_DoSomeThing");

         //---------------------------------------------------------------------
         // Konnte Funktionsadresse geladen werden ?
         //---------------------------------------------------------------------
         if (NULL == lpfn)
         {
            bRet = FALSE;
            MessageBox (NULL, szDLLPfad, "Funktion konnte nicht geladen werden",
                        MB_OK|MB_TASKMODAL|MB_ICONSTOP);
         }
         else
         {
	    //------------------------------------------------------------------
   	    // Aufruf der geladenen Funktionaddresse. Die Funktion liefert
            // den Zeiger auf eine in der DLL vorhandene Klasse zurck
            // ist der Aufruf nicht erfolgreich, so wird NULL zurckgegeben
      	    //------------------------------------------------------------------
            test = (*lpfn) ();
            if (test)
            {
               test->ShowName();
            }
         }

         //---------------------------------------------------------------------
         // Wenn die DLL nicht mehr gebraucht wird, wieder entladen
         //---------------------------------------------------------------------
         FreeLibrary (hInstDLL);
      }
   }
   return 0;
}

